"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class AlgorithmBase {
    get best() {
        return this.population.best;
    }
    get progress() {
        return this.termination.progress;
    }
    get hasReached() {
        return this.termination.hasReached(this);
    }
    reset() {
        this.population.init();
        this.termination.init();
    }
    step() {
        if (this.hasReached) {
            return;
        }
        const { parents, population } = this.selection.select(this.population.chromosomes);
        const offspring = this.crossover.cross(parents, this.crossoverProbability);
        offspring.forEach(chromosome => this.mutation.mutate(chromosome, this.mutationProbability));
        const newGeneration = this.reinsertion.select(population, offspring, parents);
        newGeneration.forEach(chromosome => chromosome.fitness = this.fitness.evaluate(chromosome));
        this.population.update(newGeneration);
    }
}
exports.AlgorithmBase = AlgorithmBase;
//# sourceMappingURL=AlgorithmBase.js.map